# coding: utf-8

from __future__ import absolute_import
import unittest

from flask import json
from six import BytesIO

from openapi_server.models.fuel import Fuel  # noqa: E501
from openapi_server.models.fuel_detail import FuelDetail  # noqa: E501
from openapi_server.models.fuel_monthly_average import FuelMonthlyAverage  # noqa: E501
from openapi_server.models.fuel_price import FuelPrice  # noqa: E501
from openapi_server.models.gold import Gold  # noqa: E501
from openapi_server.models.gold_average import GoldAverage  # noqa: E501
from openapi_server.test import BaseTestCase


class TestDefaultController(BaseTestCase):
    """DefaultController integration test stubs"""

    def test_controller_get_all_fuel_price(self):
        """Test case for controller_get_all_fuel_price

        Returns a list of gold price in given month.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/fuels/price',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_average_gold_price(self):
        """Test case for controller_get_average_gold_price

        Returns a average of gold price in given month.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/golds/{month_id}/average'.format(month_id=56),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_average_monthly_gold_price(self):
        """Test case for controller_get_average_monthly_gold_price

        Returns a monthly average price.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/golds/average',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_fuel(self):
        """Test case for controller_get_fuel

        Returns a history of fuel price.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/fuels',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_fuel_changing(self):
        """Test case for controller_get_fuel_changing

        Returns a list of gold price in given month.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/fuels/flowCount',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_fuel_price(self):
        """Test case for controller_get_fuel_price

        Returns a list of gold price in given month.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/fuels/price/{fuel_id}'.format(fuel_id=56),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_fuel_price_by_month(self):
        """Test case for controller_get_fuel_price_by_month

        Returns a list of gold price in given month.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/fuels/priceByMonth/{month_id}'.format(month_id=56),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_gold_price(self):
        """Test case for controller_get_gold_price

        Returns a history of gold price.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/golds',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_gold_price_in_month(self):
        """Test case for controller_get_gold_price_in_month

        Returns a list of gold price in given month.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/golds/{month_id}'.format(month_id=56),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_highest_gold_price(self):
        """Test case for controller_get_highest_gold_price

        Returns highest gold price.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/golds/highest',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_lowest_gold_price(self):
        """Test case for controller_get_lowest_gold_price

        Returns lowest gold price.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/golds/lowest',
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))

    def test_controller_get_monthly_average_fuel_price(self):
        """Test case for controller_get_monthly_average_fuel_price

        Returns a list of gold price in given month.
        """
        headers = { 
            'Accept': 'application/json',
        }
        response = self.client.open(
            '/gold-fuel/fuels/monthlyAverage/{fuel_id}'.format(fuel_id=56),
            method='GET',
            headers=headers)
        self.assert200(response,
                       'Response body is : ' + response.data.decode('utf-8'))


if __name__ == '__main__':
    unittest.main()
